package com.ajja.service.bootstrap.common.impl.quarkus.sql;

import com.ajja.service.bootstrap.common.application.sql.IPreparedStatement;
import com.ajja.service.bootstrap.common.application.sql.IResultSet;
import com.ajja.service.bootstrap.common.application.sql.exception.SQLException;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.Timestamp;
import java.util.Date;

/**
 * PreparedStatementImpl
 */
public final class PreparedStatementImpl implements IPreparedStatement {

    private final Connection connection;

    private final PreparedStatement preparedStatement;

    /**
     * PreparedStatementImpl
     *
     * @param connection Connection
     * @param sql String
     * @throws SQLException exception
     */
    public PreparedStatementImpl(final Connection connection, final String sql) throws SQLException {
        try {
            this.connection = connection;
            this.preparedStatement = connection.prepareStatement(sql);
        } catch (NullPointerException e) {
            throw new SQLException("A connection must be exist.");
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    /**
     * PreparedStatementImpl
     *
     * @param connection Connection
     * @param sql String
     * @param autoGeneratedKeys int
     * @throws SQLException exception
     */
    public PreparedStatementImpl(final Connection connection, final String sql, final int autoGeneratedKeys) throws SQLException {
        try {
            this.connection = connection;
            this.preparedStatement = connection.prepareStatement(sql, autoGeneratedKeys);
        } catch (NullPointerException e) {
            throw new SQLException("A connection must be exist.");
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void close() throws SQLException {
        try {
            if (preparedStatement != null) {
                preparedStatement.close();
            }

            if (connection != null) {
                connection.close();
            }
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public IResultSet executeQuery() throws SQLException {
        try {
            return new ResultSetImpl(preparedStatement.executeQuery());
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public int executeUpdate() throws SQLException {
        try {
            return preparedStatement.executeUpdate();
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public boolean execute() throws SQLException {
        try {
            return preparedStatement.execute();
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public IResultSet getGeneratedKeys() throws SQLException {
        try {
            return new ResultSetImpl(preparedStatement.getGeneratedKeys());
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void setString(int parameterIndex, String value) throws SQLException {
        try {
            preparedStatement.setString(parameterIndex, value);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void setInt(int parameterIndex, int value) throws SQLException {
        try {
            preparedStatement.setInt(parameterIndex, value);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void setLong(int parameterIndex, long value) throws SQLException {
        try {
            preparedStatement.setLong(parameterIndex, value);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void setFloat(int parameterIndex, float value) throws SQLException {
        try {
            preparedStatement.setFloat(parameterIndex, value);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void setDouble(int parameterIndex, double value) throws SQLException {
        try {
            preparedStatement.setDouble(parameterIndex, value);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void setBoolean(int parameterIndex, boolean value) throws SQLException {
        try {
            preparedStatement.setBoolean(parameterIndex, value);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void setDate(int parameterIndex, Date value) throws SQLException {
        try {
            preparedStatement.setTimestamp(parameterIndex, new Timestamp(value.getTime()));
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public void setObject(int parameterIndex, Object value) throws SQLException {
        try {
            preparedStatement.setObject(parameterIndex, value);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }
}
